package superbal;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

public class Keyboard implements KeyListener
{
  public Game game;

  public final int ESC_KEY   = 0;
  public final int Q_KEY     = 1;
  public final int C_KEY     = 2;
  public final int N_KEY     = 3;
  public final int I_KEY     = 4;
  public final int P_KEY     = 5;
  public final int SP_KEY    = 6;
  public final int UP_KEY    = 7;
  public final int DOWN_KEY  = 8;
  public final int LEFT_KEY  = 9;
  public final int RIGHT_KEY = 10;
  public final int ENTER_KEY = 11;

  public Keyboard(Game game)
  { this.game = game;
    game.world.Pressed[ESC_KEY]   = false;
    game.world.Pressed[Q_KEY]     = false;
    game.world.Pressed[C_KEY]     = false;
    game.world.Pressed[N_KEY]     = false;
    game.world.Pressed[I_KEY]     = false;
    game.world.Pressed[P_KEY]     = false;
    game.world.Pressed[SP_KEY]    = false;
    game.world.Pressed[UP_KEY]    = false;
    game.world.Pressed[DOWN_KEY]  = false;
    game.world.Pressed[LEFT_KEY]  = false;
    game.world.Pressed[RIGHT_KEY] = false;
    game.world.Pressed[ENTER_KEY] = false;
  }

  public void keyPressed(KeyEvent e)
  { switch(e.getKeyCode())
    { case 27: game.world.Pressed[ESC_KEY]   = true; break;
      case 81: if(true || game.EXIT_VM)
               game.world.Pressed[Q_KEY]     = true; break;
      case 67: game.world.Pressed[C_KEY]     = true; break;
      case 78: game.world.Pressed[N_KEY]     = true; break;
      case 73: game.world.Pressed[I_KEY]     = true; break;
      case 80: game.world.Pressed[P_KEY]     = true; break;
      case 32: game.world.Pressed[SP_KEY]    = true; break;
      case 38: game.world.Pressed[UP_KEY]    = true; break;
      case 40: game.world.Pressed[DOWN_KEY]  = true; break;
      case 37: game.world.Pressed[LEFT_KEY]  = true; break;
      case 39: game.world.Pressed[RIGHT_KEY] = true; break;
      case 10: game.world.Pressed[ENTER_KEY] = true; break;
    }
  }

  public void keyReleased(KeyEvent e)
  { switch(e.getKeyCode())
    { case 27: game.world.Pressed[ESC_KEY]   = false; break;
      case 81: if(true || game.EXIT_VM)
               game.world.Pressed[Q_KEY]     = false; break;
      case 67: game.world.Pressed[C_KEY]     = false; break;
      case 78: game.world.Pressed[N_KEY]     = false; break;
      case 73: game.world.Pressed[I_KEY]     = false; break;
      case 80: game.world.Pressed[P_KEY]     = false; break;
      case 32: game.world.Pressed[SP_KEY]    = false; break;
      case 38: game.world.Pressed[UP_KEY]    = false; break;
      case 40: game.world.Pressed[DOWN_KEY]  = false; break;
      case 37: game.world.Pressed[LEFT_KEY]  = false; break;
      case 39: game.world.Pressed[RIGHT_KEY] = false; break;
      case 10: game.world.Pressed[ENTER_KEY] = false; break;
    }
  }

  public void keyTyped(KeyEvent e) {}

}
