package superbal;

import java.awt.Panel;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Color;
import java.awt.Font;

public class View extends Panel implements Runnable
{

//____________________________________________________________________________ ATTRIBUTS

  public Game game;

  final int pause = 20;

  final Color Sbc1 = new Color(16,  96,  0  );
  final Color Sbc2 = new Color(15,  86,  0  );
  final Color Sbc3 = new Color(28,  170, 0  );
  final Color Sbc4 = new Color(34,  209, 0  );
  final Color Sbc5 = new Color(21,  127, 0  );
  final Color Ibc1 = new Color(96,  96,  96 );
  final Color Ibc2 = new Color(81,  81,  81 );
  final Color Ibc3 = new Color(147, 147, 147);
  final Color Ibc4 = new Color(183, 183, 183);
  final Color Ibc5 = new Color(114, 114, 114);
  final Color Ebc1 = new Color(35,  35,  35 );
  final Color Ebc2 = new Color(35,  35,  128);
  final Color Ebc3 = new Color(128, 35,  255);
  final Color Ebc4 = new Color(221, 35,  255);
  final Color Ebc5 = new Color(251, 35,  255);
  final Color Ebc  = new Color(160, 0,   0  );
  final Color Bkc  = new Color(35,  35,  128);

  public final int INTRO         = 0;
  public final int ECRANS        = 1;
  public final int NIVEAU        = 2;
  public final int FELICITATIONS = 3;
  public final int INFORMATION1  = 4;
  public final int INFORMATION2  = 5;
  public int STATE;
  boolean PAINTING;

  Graphics graphics_buffer;
  Image image_buffer;

  int LINE;

  Thread thread;
  boolean RUN;

//____________________________________________________________________________ CONSTRUCTION

  public View(Game game)
  { this.game = game;
    addKeyListener(game.keyboard);
    PAINTING = false;
  }

//____________________________________________________________________________ RUNNABLE

  public void run()
  { RUN = true;
    while(RUN) 
    { try { thread.sleep(pause); } catch(Exception e) {}
      if(!PAINTING)
      { PAINTING = true;
        repaint();
      }
    }
  }

  public void start() { (thread = new Thread(this)).start(); }

  public void end()
  { RUN = false;
    graphics_buffer = null;
    image_buffer = null;
    try { thread.join(); } catch(Exception e) { e.printStackTrace(); }
    thread = null;
    game = null;
  }

//____________________________________________________________________________ PAINT

  public void setBounds(int i, int j, int k, int l)
  { super.setBounds(i, j, k, l);
    init_graphics();
  }

  public void init_graphics()
  { image_buffer = createImage(getSize().width, getSize().height);
    graphics_buffer = image_buffer.getGraphics();
  }

  public void update(Graphics g)
  { try
    { if(image_buffer == null) init_graphics();
      paint(graphics_buffer);
      g.drawImage(image_buffer, 0, 0, this);
    }
    catch(NullPointerException e) {}
  }

  public void paint(Graphics g)
  { switch(STATE)
    { case INTRO:         Intro(g);         break;
      case INFORMATION1:  Information1(g);  break;
      case INFORMATION2:  Information2(g);  break;
      case ECRANS:        Ecrans(g);        break;
      case NIVEAU:        Niveau(g);        break;
      case FELICITATIONS: Felicitations(g); break;
    }
    PAINTING = false;
  }

//____________________________________________________________________________ TEXTES

  public void text_screen(Graphics g)
  { g.setColor(Color.black);
    g.fillRect(0, 0, 640, 400);
    g.setFont(new Font("arial", 1, 14));
    g.setColor(new Color(201, 201, 201));
    LINE = 0;
  }

  public void writeln() { LINE++; }

  public void writeln(Graphics g, String line)
  { LINE++;
    g.drawString(line, 20, 20 + LINE * 20);
  }

  public void Intro(Graphics g)
  { text_screen(g);
    g.setColor(new Color(160, 0, 0));
    writeln(g, "SUPERBALL");
    g.setColor(new Color(201, 201, 201));
    writeln();
    writeln(g, "a @Cave_Man product");
    writeln(); writeln();
    writeln(g, "press    N    for New Game");
    writeln(g, "         I    for Information ");
//    if(game.EXIT_VM) writeln(g, "         Q    to Quit ");
//    else writeln();
    writeln();
    writeln(); writeln();
    writeln(g, "SCORE :  " + game.world.score);
    writeln(); writeln();
    g.setColor(new Color(147, 147, 147));
    writeln(g, "SPEED : " + game.world.spb + " (press up or down key to change)");
  }

  public void Information1(Graphics g)
  { text_screen(g);
    g.setColor(new Color(160, 0, 0));
    writeln(g, "SUPERBALL INFORMATION");
    g.setColor(new Color(201, 201, 201));
    writeln();
    writeln(g, "     Le but du jeu est de casser toutes les briques vertes");
    writeln(g, "\340 l'aide d'un pallet et d'une balle rebondissante.");
    writeln();
    writeln(g, "     Au d\351but d'une partie, il n'y pas de pallet : dirigez");
    writeln(g, "la balle \340 l'aide des fl\350ches et de la barre d'espacement.");
    writeln(g, "Les portes surmont\351es d'une inscription verte sont ouvertes.");
    writeln(g, "Celles dont l'inscriptoin est rouge sont ferm\351es. Pour passer");
    writeln(g, "une porte, placez la balle devant et appuyez sur la touche");
    writeln(g, "[fl\350che haut].");
    writeln();
    writeln(g, "     Vous voici alors dans un \351cran o\371 cette fois, c'est le");
    writeln(g, "pallet que vous controlez : appuyez sur la barre d'espacement");
    writeln(g, "pour lancer la balle...");
    writeln();
    g.setColor(new Color(147, 147, 147));
    writeln(g, "                        ( press Entr )");
  }

  public void Information2(Graphics g)
  { text_screen(g);
    g.setColor(new Color(160, 0, 0));
    writeln(g, "SUPERBALL INFORMATION");
    g.setColor(new Color(201, 201, 201));
    writeln();
    writeln(g, "     De temps en temps, une capsule tombera d'une brique");
    writeln(g, "cass\351e. Si le pallet rentre en contact avec cette capsule, il");
    writeln(g, "pourra, celon la couleur de cette derniere, gagner une vie ou");
    writeln(g, "se retrouver muni de l'option SCOTCH ou de l'option TIR.");
    writeln();
    writeln(g, "     Il est possible, \340 tout moment, de retourner \340 l'\351cran");
    writeln(g, "des portes en appuyant sur Echap. Mais alors les briques cass\351es");
    writeln(g, "dans l'\351cran quitt\351 seront de nouveau l\340 lorsque vous y");
    writeln(g, "retournerez.");
    writeln();
    writeln(g, "     Lorsque la partie est termin\351e, vous pouvez en recommencer");
    writeln(g, "une en appuyant sur 'C' (pour 'Continuer') : vous retrouverez");
    writeln(g, "alors autand de portes ouvertes que lors de la partie pr\351c\351dante,");
    writeln(g, "mais le score sera remis \340 z\351ro.");
    writeln();
    g.setColor(new Color(147, 147, 147));
    writeln(g, "                        ( press Entr )");
  }

  public void Felicitations(Graphics g)
  { text_screen(g);
    g.setColor(new Color(160, 0, 0));
    writeln(g, "FELICITATIONS !");
    g.setColor(new Color(201, 201, 201));
    writeln(); writeln();
    writeln(g, "Vous avez pulv\351ris\351 toutes les briques");
    writeln(); writeln();
    g.setColor(new Color(147, 147, 147));
    writeln(g, "                        ( press Entr )");
  }

//____________________________________________________________________________ GRAPHIQUES

  public void Clear(Graphics g, Color color)
  { g.setColor(color);
    g.fillRect(0, 0, 640, 400);
    g.setColor(Color.black);
    g.fillRect(0, 370, 640, 7);
  }

  public void Pt(Graphics g, int x, int y, Color color)
  { g.setColor(color);
    g.fillRect(x * 2, y * 2, 2, 2);
  }

  public void Balle(Graphics g, int x, int y, Color c1, Color c2, Color c3)
  { g.setColor(c1);
    g.fillRect(2 * x - 2, 2 * y - 6, 2, 2);
    g.fillRect(2 * x - 4, 2 * y - 4, 2, 2);
    g.fillRect(2 * x - 6, 2 * y - 2, 2, 6);
    g.fillRect(2 * x - 4, 2 * y + 2, 2, 4);
    g.fillRect(2 * x - 2, 2 * y + 4, 2, 4);
    g.fillRect(2 * x, 2 * y + 6, 6, 2);
    g.setColor(c2);
    g.fillRect(2 * x, 2 * y - 6, 6, 2);
    g.fillRect(2 * x - 2, 2 * y - 4, 4, 2);
    g.fillRect(2 * x - 4, 2 * y - 2, 4, 4);
    g.fillRect(2 * x - 2, 2 * y + 2, 4, 2);
    g.fillRect(2 * x, 2 * y + 4, 4, 2);
    g.setColor(c3);
    g.fillRect(2 * x + 2, 2 * y - 4, 6, 8);
    g.fillRect(2 * x, 2 * y - 2, 2, 4);
    g.fillRect(2 * x + 4, 2 * y + 4, 4, 2);
    g.fillRect(2 * x + 8, 2 * y - 2, 2, 6);
  }

  public void Pallet(Graphics g, int x, int y, Color c1, Color c2, Color c3)
  { g.setColor(c1);
    g.fillRect(2 * x - 34, 2 * y, 70, 4);
    g.fillRect(2 * x - 36, 2 * y + 2, 2, 6);
    g.fillRect(2 * x + 36, 2 * y + 2, 2, 6);
    g.fillRect(2 * x - 34, 2 * y + 6, 2, 4);
    g.fillRect(2 * x + 34, 2 * y + 6, 2, 4);
    g.fillRect(2 * x - 32, 2 * y + 8, 2, 4);
    g.fillRect(2 * x + 32, 2 * y + 8, 2, 4);
    g.fillRect(2 * x - 30, 2 * y + 10, 2, 2);
    g.fillRect(2 * x + 30, 2 * y + 10, 2, 2);
    g.setColor(c2);
    g.fillRect(2 * x - 34, 2 * y + 4, 6, 2);
    g.fillRect(2 * x - 32, 2 * y + 6, 4, 2);
    g.fillRect(2 * x - 30, 2 * y + 8, 2, 2);
    g.fillRect(2 * x + 30, 2 * y + 4, 6, 2);
    g.fillRect(2 * x + 30, 2 * y + 6, 4, 2);
    g.fillRect(2 * x + 30, 2 * y + 8, 2, 2);
    g.fillRect(2 * x - 26, 2 * y + 4, 54, 2);
    g.fillRect(2 * x - 26, 2 * y + 6, 2, 2);
    g.fillRect(2 * x + 26, 2 * y + 6, 2, 2);
    if(y < 190)
    {      if(game.world.CShoot.possible)  c3 = game.world.CShoot.col;
      else if(game.world.CScotch.possible) c3 = game.world.CScotch.col;
    }
    g.setColor(c3);
    g.fillRect(2 * x - 24, 2 * y + 6, 50, 4);
  }

  public void Tir(Graphics g, int x, int y, Color c)
  { for(int i = y; i >= y - 5; i--) Pt(g, x, i, c);
  }

  public void Brik(Graphics g, int x, int y, Color c1, Color c2, Color c3, Color c4, Color c5)
  { g.setColor(c1);
    g.fillRect(2 * x, 2 * y, 60, 2);
    g.fillRect(2 * x + 4, 2 * y + 2, 52, 2);
    g.setColor(c2);
    g.fillRect(2 * x, 2 * y + 2, 4, 10);
    g.fillRect(2 * x + 4, 2 * y + 4, 4, 6);
    g.setColor(c3);
    g.fillRect(2 * x + 4, 2 * y + 10, 52, 2);
    g.fillRect(2 * x, 2 * y + 12, 60, 2);
    g.setColor(c4);
    g.fillRect(2 * x + 52, 2 * y + 4, 4, 6);
    g.fillRect(2 * x + 56, 2 * y + 2, 4, 10);
    g.setColor(c5);
    g.fillRect(2 * x + 8, 2 * y + 4, 44, 6);
  }

  public void BrikE(Graphics g, int x, int y, Color c1, Color c2, Color c3, Color c4, Color c5)
  { g.setColor(c1);
    g.fillRect(2 * x, 2 * y, 60, 2);
    g.fillRect(2 * x, 2 * y + 12, 60, 2);
    g.fillRect(2 * x, 2 * y + 2, 2, 10);
    g.fillRect(2 * x + 58, 2 * y + 2, 2, 10);
    g.setColor(c2);
    g.fillRect(2 * x + 2, 2 * y + 2, 56, 10);
    Balle(g, x + 15, y + 3, c3, c4, c5);
  }

  public void BrikBonus(Graphics g, int x, int y)
  { int c = 75;
    for(int i = y; i <= y + 6; i++)
    { g.setColor(new Color(c, c, c));
      g.fillRect(2 * x, 2 * i, 60, 2);
      c += 30;
    }
  }

  public void BrikB(Graphics g, int x, int y, Color c)
  { BrikBonus(g, x, y);
    g.setColor(c);
    g.fillRect(2 * x + 22, 2 * y + 4, 6, 6);
    g.fillRect(2 * x + 20, 2 * y + 2, 16, 2);
    g.fillRect(2 * x + 20, 2 * y + 10, 16, 2);
    g.fillRect(2 * x + 28, 2 * y + 6, 8, 2);
    g.fillRect(2 * x + 36, 2 * y + 4, 2, 8);
    g.fillRect(2 * x + 38, 2 * y + 8, 2, 4);
  }

  public void BrikO(Graphics g, int x, int y, Color c)
  { BrikBonus(g, x, y);
    g.setColor(c);
    g.fillRect(2 * x + 16, 2 * y + 4, 6, 6);
    g.fillRect(2 * x + 34, 2 * y + 4, 6, 6);
    g.fillRect(2 * x + 16, 2 * y + 2, 24, 2);
    g.fillRect(2 * x + 16, 2 * y + 10, 24, 2);
  }

  public void BrikN(Graphics g, int x, int y, Color c)
  { BrikBonus(g, x, y);
    g.setColor(c);
    g.fillRect(2 * x + 18, 2 * y + 2, 6, 10);
    g.fillRect(2 * x + 34, 2 * y + 2, 6, 10);
    g.fillRect(2 * x + 24, 2 * y + 2, 2, 2);
    g.fillRect(2 * x + 26, 2 * y + 4, 2, 2);
    g.fillRect(2 * x + 28, 2 * y + 6, 2, 2);
    g.fillRect(2 * x + 30, 2 * y + 8, 2, 2);
    g.fillRect(2 * x + 32, 2 * y + 10, 2, 2);
  }

  public void BrikU(Graphics g, int i, int j, Color color)
  { BrikBonus(g, i, j);
    g.setColor(color);
    g.fillRect(2 * i + 16, 2 * j + 2, 6, 10);
    g.fillRect(2 * i + 34, 2 * j + 2, 6, 10);
    g.fillRect(2 * i + 22, 2 * j + 10, 12, 2);
  }

  public void BrikS(Graphics g, int x, int y, Color c)
  { BrikBonus(g, x, y);
    for(int i = x + 8; i <= x + 19; i++)
    { Pt(g, i, y + 1, c);
      Pt(g, i, y + 3, c);
      Pt(g, i, y + 5, c);
    }
    for(int i = x + 8; i <= x + 10; i++) Pt(g, i, y + 2, c);
    for(int i = x + 17; i <= x + 19; i++) Pt(g, i, y + 4, c);
  }

  public void Capsule(Graphics g, int x, int y, Color c1, Color c2)
  { for(int i = x - 5; i <= x + 5; i++)
    { Pt(g, i, y - 2, c1);
      Pt(g, i, y + 2, c1);
    }
    for(int i = x - 6; i <= x - 5; i++) for(int j = y - 1; j <= y + 1; j++) Pt(g, i, j, c1);
    for(int i = x + 5; i <= x + 6; i++) for(int j = y - 1; j <= y + 1; j++) Pt(g, i, j, c1);
    Pt(g, x - 4, y - 1, c1);
    Pt(g, x + 4, y - 1, c1);
    Pt(g, x + 4, y, c2);
    Pt(g, x - 4, y + 1, c1);
    Pt(g, x + 4, y + 1, c1);
    Pt(g, x - 4, y, c2);
    for(int i = x - 3; i <= x + 3; i++) for(int j = y - 1; j <= y + 1; j++) Pt(g, i, j, c2);
 }

  public void Porte(Graphics g, int x, int y)
  { Color c1 = Color.white;
    Color c2 = Color.gray;
    Color c3 = Color.black;
    g.setColor(c1);
    g.fillRect(2 * x, 2 * y, 2, 42);
    g.fillRect(2 * x + 58, 2 * y, 2, 42);
    g.fillRect(2 * x + 2, 2 * y, 56, 2);
    g.setColor(c2);
    g.fillRect(2 * x + 2, 2 * y + 2, 4, 40);
    g.fillRect(2 * x + 54, 2 * y + 2, 4, 40);
    g.fillRect(2 * x + 6, 2 * y + 2, 48, 4);
    g.setColor(c3);
    g.fillRect(2 * x + 6, 2 * y + 6, 48, 36);
  }

  public void DetecteurD(Graphics g, int x, int y)
  { Color c1 = Color.black;
    Color c2 = new Color(201, 201, 201);
    Color c3 = new Color(137, 137, 137);
    Color c4 = Color.red;
    for(int i = x; i <= x + 1; i++) for(int j = y; j <= y + 8; j++) Pt(g, i, j, c1);
    for(int i = y + 1; i <= y + 7; i++) Pt(g, x + 2, i, c2);
    for(int i = y + 3; i <= y + 5; i++) Pt(g, x + 3, i, c3);
    Pt(g, x + 4, y + 4, c3);
    Pt(g, x, y + 2, c4);
  }

  public void DetecteurG(Graphics g, int x, int y)
  { Color c1 = Color.black;
    Color c2 = new Color(201, 201, 201);
    Color c3 = new Color(137, 137, 137);
    Color c4 = Color.red;
    for(int i = x - 1; i <= x; i++) for(int j = y; j <= y + 8; j++) Pt(g, i, j, c1);
    for(int i = y + 1; i <= y + 7; i++) Pt(g, x - 2, i, c1);
    for(int i = y + 3; i <= y + 5; i++) Pt(g, x - 3, i, c3);
    Pt(g, x - 4, y + 4, c3);
    Pt(g, x, y + 2, c4);
  }

  public void Rayon(Graphics g, int y)
  { if(game.world.cont % 50 < 25) Rayon1(g, y);
    else Rayon2(g, y);
  }

  public void Rayon1(Graphics g, int y)
  { Color c = Color.green;
    int k = 1;
    for(int i = 5; i <= 314; i++)
    { if(k == 10) k = 1;
           if(k == 1) Pt(g, i, y, c);
      else if(k == 2) Pt(g, i, y, c);
      else if(k == 3) Pt(g, i, y + 1, c);
      else if(k == 4) Pt(g, i, y, c);
      else if(k == 5) Pt(g, i, y - 1, c);
      else if(k == 6) Pt(g, i, y - 1, c);
      else if(k == 7) Pt(g, i, y - 1, c);
      else if(k == 8) Pt(g, i, y, c);
      else if(k == 9) Pt(g, i, y, c);
      k++;
    }
  }

  public void Rayon2(Graphics g, int y)
  { Color c = Color.green;
    int k = 1;
    for(int i = 5; i <= 314; i++)
    { if(k == 10) k = 1;
           if(k == 1) Pt(g, i, y - 1, c);
      else if(k == 2) Pt(g, i, y - 1, c);
      else if(k == 3) Pt(g, i, y, c);
      else if(k == 4) Pt(g, i, y + 1, c);
      else if(k == 5) Pt(g, i, y, c);
      else if(k == 6) Pt(g, i, y, c);
      else if(k == 7) Pt(g, i, y - 1, c);
      else if(k == 8) Pt(g, i, y - 1, c);
      else if(k == 9) Pt(g, i, y, c);
      k++;
    }
  }

  public void FlecheD(Graphics g, int x, int y, Color c)
  { Color _c = c;
    if(game.world.cont % 10 != 0) _c = Color.black;
    for(int i = x; i <= x + 5; i++) Pt(g, i, y, _c);
    Pt(g, x + 4, y - 1, _c);
    Pt(g, x + 3, y - 2, _c);
    Pt(g, x + 4, y + 1, _c);
    Pt(g, x + 3, y + 2, _c);
  }

  public void FlecheG(Graphics g, int x, int y, Color c)
  { Color _c = c;
    if(game.world.cont % 10 != 0) _c = Color.black;
    for(int i = x; i <= x + 5; i++) Pt(g, i, y, _c);
    Pt(g, x + 1, y - 1, _c);
    Pt(g, x + 2, y - 2, _c);
    Pt(g, x + 1, y + 1, _c);
    Pt(g, x + 2, y + 2, _c);
  }

  public void PanneauEnd(Graphics g, int i, int j)
  { Color color = Color.black;
    Color color1 = Bkc;
    Color color2 = Color.white;
    for(int k = i - 4; k <= i + 4; k++) for(int i3 = j + 17; i3 <= j + 18; i3++) Pt(g, k, i3, color);
    for(int l = j + 8; l <= j + 31; l++) Pt(g, i + 5, l, color);
    for(int j3 = i + 6; j3 <= i + 17; j3++) Pt(g, j3, j + 31, color);
    for(int k3 = j + 6; k3 <= j + 10; k3++) Pt(g, i + 17, k3, color);
    for(int i1 = j + 11; i1 <= j + 23; i1++) Pt(g, i + 16, i1, color);
    for(int j1 = j + 24; j1 <= j + 30; j1++) Pt(g, i + 17, j1, color);
    Pt(g, i + 6, j + 7, color);
    Pt(g, i + 7, j + 6, color);
    Pt(g, i + 8, j + 5, color);
    Pt(g, i + 9, j + 4, color);
    Pt(g, i + 10, j + 3, color);
    Pt(g, i + 11, j + 2, color);
    Pt(g, i + 12, j + 1, color);
    Pt(g, i + 13, j + 2, color);
    Pt(g, i + 14, j + 3, color);
    Pt(g, i + 15, j + 4, color);
    Pt(g, i + 16, j + 5, color);
    for(int k1 = i + 6; k1 <= i + 15; k1++) for(int l3 = j + 8; l3 <= j + 30; l3++) Pt(g, k1, l3, color2);
    for(int i4 = j + 24; i4 <= j + 30; i4++) Pt(g, i + 16, i4, color2);
    for(int j4 = j + 6; j4 <= j + 10; j4++) Pt(g, i + 16, j4, color2);
    for(int k4 = i + 7; k4 <= i + 15; k4++) Pt(g, k4, j + 7, color2);
    for(int l4 = i + 8; l4 <= i + 15; l4++) Pt(g, l4, j + 6, color2);
    for(int i5 = i + 9; i5 <= i + 15; i5++) Pt(g, i5, j + 5, color2);
    for(int j5 = i + 10; j5 <= i + 14; j5++) Pt(g, j5, j + 4, color2);
    for(int k5 = i + 11; k5 <= i + 13; k5++) Pt(g, k5, j + 3, color2);
    Pt(g, i + 12, j + 2, color2);
    int l5 = i + 8;
    for(int l1 = j + 9; l1 <= j + 11; l1++) Pt(g, l5, l1, color1);
    for(int i2 = j + 14; i2 <= j + 19; i2++) Pt(g, l5, i2, color1);
    for(int j2 = j + 21; j2 <= j + 26; j2++) Pt(g, l5, j2, color1);
    l5 = i + 9;
    Pt(g, l5, j + 7, color1);
    Pt(g, l5, j + 8, color1);
    Pt(g, l5, j + 10, color1);
    Pt(g, l5, j + 12, color1);
    Pt(g, l5, j + 15, color1);
    Pt(g, l5, j + 21, color1);
    Pt(g, l5, j + 26, color1);
    l5 = i + 10;
    Pt(g, l5, j + 7, color1);
    Pt(g, l5, j + 10, color1);
    Pt(g, l5, j + 12, color1);
    Pt(g, l5, j + 16, color1);
    Pt(g, l5, j + 21, color1);
    Pt(g, l5, j + 26, color1);
    l5 = i + 11;
    Pt(g, l5, j + 7, color1);
    Pt(g, l5, j + 12, color1);
    Pt(g, l5, j + 17, color1);
    Pt(g, l5, j + 22, color1);
    Pt(g, l5, j + 26, color1);
    l5 = i + 12;
    Pt(g, l5, j + 7, color1);
    Pt(g, l5, j + 12, color1);
    for(int k2 = j + 14; k2 <= j + 19; k2++) Pt(g, l5, k2, color1);
    for(int l2 = j + 23; l2 <= j + 25; l2++) Pt(g, l5, l2, color1);
  }

  public void PanneauExit(Graphics g, int i, int j)
  { Color color = Color.black;
    Color color1 = Bkc;
    Color color2 = Color.white;
    for(int k = i - 4; k <= i + 4; k++) for(int l2 = j + 17; l2 <= j + 18; l2++) Pt(g, k, l2, color);
    for(int l = j + 4; l <= j + 27; l++) Pt(g, i + 5, l, color);
    for(int i3 = i + 6; i3 <= i + 9; i3++) Pt(g, i3, j + 4, color);
    Pt(g, i + 10, j + 3, color); for(int j3 = i + 11; j3 <= i + 16; j3++) Pt(g, j3, j + 2, color);
    for(int k3 = j + 3; k3 <= j + 8; k3++) Pt(g, i + 16, k3, color);
    for(int i1 = j + 9; i1 <= j + 17; i1++) Pt(g, i + 15, i1, color);
    for(int j1 = j + 18; j1 <= j + 26; j1++) Pt(g, i + 16, j1, color);
    Pt(g, i + 6, j + 28, color);
    Pt(g, i + 7, j + 29, color);
    Pt(g, i + 8, j + 30, color);
    Pt(g, i + 9, j + 31, color);
    Pt(g, i + 15, j + 27, color);
    Pt(g, i + 10, j + 32, color);
    Pt(g, i + 11, j + 31, color);
    Pt(g, i + 12, j + 30, color);
    Pt(g, i + 13, j + 29, color);
    Pt(g, i + 14, j + 28, color);
    for(int k1 = i + 6; k1 <= i + 14; k1++) for(int l3 = j + 5; l3 <= j + 27; l3++) Pt(g, k1, l3, color2);
    for(int l1 = i + 11; l1 <= i + 15; l1++) for(int i4 = j + 3; i4 <= j + 4; i4++) Pt(g, l1, i4, color2);
    Pt(g, i + 10, j + 4, color2);
    for(int j4 = j + 5; j4 <= j + 8; j4++) Pt(g, i + 15, j4, color2);
    for(int k4 = j + 18; k4 <= j + 26; k4++) Pt(g, i + 15, k4, color2);
    for(int l4 = i + 7; l4 <= i + 13; l4++) Pt(g, l4, j + 28, color2);
    for(int i5 = i + 8; i5 <= i + 12; i5++) Pt(g, i5, j + 29, color2);
    for(int j5 = i + 9; j5 <= i + 11; j5++) Pt(g, j5, j + 30, color2);
    Pt(g, i + 10, j + 31, color2);
    int k5 = i + 8;
    for(int i2 = j + 9; i2 <= j + 11; i2++) Pt(g, k5, i2, color1);
    Pt(g, k5, j + 14, color1);
    Pt(g, k5, j + 18, color1);
    Pt(g, k5, j + 25, color1);
    k5 = i + 9;
    Pt(g, k5, j + 7, color1);
    Pt(g, k5, j + 8, color1);
    Pt(g, k5, j + 10, color1);
    Pt(g, k5, j + 12, color1);
    Pt(g, k5, j + 15, color1);
    Pt(g, k5, j + 17, color1);
    Pt(g, k5, j + 25, color1);
    k5 = i + 10;
    Pt(g, k5, j + 7, color1);
    Pt(g, k5, j + 16, color1);
    Pt(g, k5, j + 10, color1);
    Pt(g, k5, j + 12, color1);
    Pt(g, k5, j + 19, color1);
    for(int j2 = j + 21; j2 <= j + 23; j2++) Pt(g, i + 10, j2, color1);
    for(int k2 = j + 25; k2 <= j + 29; k2++) Pt(g, i + 10, k2, color1);
    k5 = i + 11;
    Pt(g, k5, j + 7, color1);
    Pt(g, k5, j + 15, color1);
    Pt(g, k5, j + 17, color1);
    Pt(g, k5, j + 12, color1);
    Pt(g, k5, j + 25, color1);
    k5 = i + 12;
    Pt(g, k5, j + 7, color1);
    Pt(g, k5, j + 14, color1);
    Pt(g, k5, j + 18, color1);
    Pt(g, k5, j + 12, color1);
    Pt(g, k5, j + 25, color1);
  }

  public void ExitG(Graphics g, int i, int j)
  { Color color = Color.black;
    Color color1 = Bkc;
    Color color2 = Color.white;
    for(int k = i; k <= i + 1; k++) for(int i3 = j; i3 <= j + 4; i3++) Pt(g, k, i3, color);
    for(int l = i - 8; l <= i + 12; l++) Pt(g, l, j + 5, color);
    for(int j3 = j + 5; j3 <= j + 8; j3++) Pt(g, i + 12, j3, color);
    for(int k3 = j + 9; k3 <= j + 11; k3++) Pt(g, i + 11, k3, color);
    for(int l3 = j + 12; l3 <= j + 13; l3++) Pt(g, i + 10, l3, color);
    for(int i1 = i + 6; i1 <= i + 9; i1++) Pt(g, i1, j + 14, color);
    for(int j1 = i - 6; j1 <= i + 5; j1++) Pt(g, j1, j + 15, color);
    Pt(g, i - 12, j + 9, color);
    Pt(g, i - 11, j + 8, color);
    Pt(g, i - 10, j + 7, color);
    Pt(g, i - 9, j + 6, color);
    Pt(g, i - 11, j + 10, color);
    Pt(g, i - 10, j + 11, color);
    Pt(g, i - 9, j + 12, color);
    Pt(g, i - 8, j + 13, color);
    Pt(g, i - 7, j + 14, color);
    for(int k1 = i - 6; k1 <= i + 5; k1++) for(int i4 = j + 6; i4 <= j + 14; i4++) Pt(g, k1, i4, color2);
    for(int l1 = i + 6; l1 <= i + 9; l1++) for(int j4 = j + 6; j4 <= j + 13; j4++) Pt(g, l1, j4, color2);
    for(int k4 = j + 6; k4 <= j + 11; k4++) Pt(g, i + 10, k4, color2);
    for(int l4 = j + 6; l4 <= j + 8; l4++) Pt(g, i + 11, l4, color2);
    for(int i5 = j + 6; i5 <= j + 13; i5++) Pt(g, i - 7, i5, color2);
    for(int j5 = j + 6; j5 <= j + 12; j5++) Pt(g, i - 8, j5, color2);
    for(int k5 = j + 7; k5 <= j + 11; k5++) Pt(g, i - 9, k5, color2);
    for(int l5 = j + 8; l5 <= j + 10; l5++) Pt(g, i - 10, l5, color2);
    Pt(g, i - 11, j + 9, color2);
    int i6 = j + 7;
    for(int i2 = i - 6; i2 <= i - 4; i2++) Pt(g, i2, i6, color1);
    for(int j2 = i + 6; j2 <= i + 10; j2++) Pt(g, j2, i6, color1);
    Pt(g, i - 2, i6, color1);
    Pt(g, i + 2, i6, color1);
    Pt(g, i + 4, i6, color1);
    i6 = j + 8;
    Pt(g, i - 6, i6, color1);
    Pt(g, i - 1, i6, color1);
    Pt(g, i + 1, i6, color1);
    Pt(g, i + 8, i6, color1);
    i6 = j + 9;
    Pt(g, i - 7, i6, color1);
    Pt(g, i, i6, color1);
    Pt(g, i + 4, i6, color1);
    Pt(g, i + 8, i6, color1);
    i6 = j + 10;
    for(int k2 = i - 7; k2 <= i - 5; k2++) Pt(g, k2, i6, color1);
    Pt(g, i + 8, i6, color1);
    Pt(g, i, i6, color1);
    Pt(g, i + 4, i6, color1);
    i6 = j + 11;
    Pt(g, i - 7, i6, color1);
    Pt(g, i - 1, i6, color1);
    Pt(g, i + 4, i6, color1);
    Pt(g, i + 8, i6, color1);
    Pt(g, i + 1, i6, color1);
    i6 = j + 12;
    for(int l2 = i - 6; l2 <= i - 4; l2++) Pt(g, l2, i6, color1);
    Pt(g, i - 2, i6, color1);
    Pt(g, i + 4, i6, color1);
    Pt(g, i + 8, i6, color1);
    Pt(g, i + 2, i6, color1);
  }

  public void Zero(Graphics g, int i, int j, Color color)
  { Pt(g, i - 1, j, color);
    Pt(g, i, j, color);
    Pt(g, i - 1, j + 5, color);
    Pt(g, i, j + 5, color);
    for(int k = j + 1; k <= j + 4; k++) Pt(g, i - 2, k, color);
    for(int l = j + 1; l <= j + 4; l++) Pt(g, i + 1, l, color);
  }

  public void Un(Graphics g, int i, int j, Color color)
  { for(int k = j; k < j + 6; k++) Pt(g, i, k, color);
    Pt(g, i - 1, j + 1, color);
    Pt(g, i - 2, j + 2, color);
  }

  public void Deux(Graphics g, int i, int j, Color color)
  { Pt(g, i - 2, j + 1, color);
    Pt(g, i - 1, j, color);
    Pt(g, i, j, color);
    Pt(g, i + 1, j + 1, color);
    Pt(g, i + 1, j + 2, color);
    Pt(g, i, j + 3, color);
    Pt(g, i - 1, j + 4, color);
    for(int k = i - 2; k <= i + 1; k++) Pt(g, k, j + 5, color);
  }

  public void Trois(Graphics g, int i, int j, Color color)
  { Pt(g, i - 2, j + 1, color);
    Pt(g, i - 1, j, color);
    Pt(g, i, j, color);
    Pt(g, i + 1, j + 1, color);
    Pt(g, i + 1, j + 2, color);
    Pt(g, i, j + 3, color);
    Pt(g, i + 1, j + 4, color);
    for(int k = i - 2; k <= i + 1; k++) Pt(g, k, j + 5, color);
  }

  public void Quatre(Graphics g, int i, int j, Color color)
  { Pt(g, i, j, color);
    Pt(g, i - 1, j + 1, color);
    Pt(g, i - 2, j + 2, color);
    Pt(g, i - 2, j + 3, color);
    Pt(g, i, j + 3, color);
    Pt(g, i, j + 5, color);
    for(int k = i - 2; k <= i + 1; k++) Pt(g, k, j + 4, color);
  }

  public void Cinq(Graphics g, int i, int j, Color color)
  { Pt(g, i - 2, j + 1, color);
    Pt(g, i + 1, j + 3, color);
    Pt(g, i + 1, j + 4, color);
    for(int k = i - 2; k <= i + 1; k++) Pt(g, k, j, color);
    for(int l = i - 2; l <= i; l++) Pt(g, l, j + 2, color);
    for(int i1 = i - 2; i1 <= i; i1++) Pt(g, i1, j + 5, color);
  }

  public void Six(Graphics g, int i, int j, Color color)
  { Pt(g, i - 2, j + 1, color);
    Pt(g, i + 1, j + 3, color);
    Pt(g, i + 1, j + 4, color);
    Pt(g, i - 2, j + 4, color);
    Pt(g, i - 2, j + 3, color);
    for(int k = i - 1; k <= i + 1; k++) Pt(g, k, j, color);
    for(int l = i - 2; l <= i; l++) Pt(g, l, j + 2, color);
    for(int i1 = i - 1; i1 <= i; i1++) Pt(g, i1, j + 5, color);
  }

  public void Sept(Graphics g, int i, int j, Color color)
  { Pt(g, i, j + 2, color);
    Pt(g, i, j + 3, color);
    Pt(g, i + 1, j + 1, color);
    Pt(g, i - 1, j + 4, color);
    Pt(g, i - 1, j + 5, color);
    for(int k = i - 2; k <= i + 1; k++) Pt(g, k, j, color);
  }

  public void Huit(Graphics g, int i, int j, Color color)
  { Pt(g, i, j, color);
    Pt(g, i - 1, j, color);
    Pt(g, i + 1, j + 1, color);
    Pt(g, i - 2, j + 1, color);
    Pt(g, i - 1, j + 2, color);
    Pt(g, i, j + 2, color);
    Pt(g, i + 1, j + 3, color);
    Pt(g, i - 2, j + 3, color);
    Pt(g, i + 1, j + 4, color);
    Pt(g, i - 2, j + 4, color);
    Pt(g, i - 1, j + 5, color);
    Pt(g, i, j + 5, color);
  }

  public void Neuf(Graphics g, int i, int j, Color color)
  { Pt(g, i, j, color);
    Pt(g, i - 1, j, color);
    Pt(g, i + 1, j + 1, color);
    Pt(g, i - 2, j + 1, color);
    Pt(g, i - 1, j + 2, color);
    Pt(g, i, j + 2, color);
    Pt(g, i + 1, j + 3, color);
    Pt(g, i + 1, j + 4, color);
    Pt(g, i + 1, j + 2, color);
    Pt(g, i - 1, j + 5, color);
    Pt(g, i, j + 5, color);
  }

  public void TBonus(Graphics g, int i, int j, Color color)
  { int l2 = j + 1;
    for(int k = i + 1; k <= i + 3; k++) Pt(g, k, l2, color);
    for(int l = i + 6; l <= i + 8; l++) Pt(g, l, l2, color);
    for(int i1 = i + 19; i1 <= i + 21; i1++) Pt(g, i1, l2, color);
    Pt(g, i + 10, l2, color);
    Pt(g, i + 13, l2, color);
    Pt(g, i + 15, l2, color);
    Pt(g, i + 17, l2, color);
    l2 = j + 2;
    Pt(g, i + 1, l2, color);
    Pt(g, i + 4, l2, color);
    Pt(g, i + 6, l2, color);
    Pt(g, i + 8, l2, color);
    Pt(g, i + 10, l2, color);
    Pt(g, i + 11, l2, color);
    Pt(g, i + 13, l2, color);
    Pt(g, i + 15, l2, color);
    Pt(g, i + 17, l2, color);
    Pt(g, i + 19, l2, color);
    l2 = j + 3;
    for(int j1 = i + 1; j1 <= i + 3; j1++) Pt(g, j1, l2, color);
    for(int k1 = i + 19; k1 <= i + 21; k1++) Pt(g, k1, l2, color);
    Pt(g, i + 6, l2, color);
    Pt(g, i + 10, l2, color);
    Pt(g, i + 12, l2, color);
    Pt(g, i + 13, l2, color);
    Pt(g, i + 15, l2, color);
    Pt(g, i + 17, l2, color);
    Pt(g, i + 8, l2, color);
    l2 = j + 4;
    Pt(g, i + 1, l2, color);
    Pt(g, i + 4, l2, color);
    Pt(g, i + 6, l2, color);
    Pt(g, i + 8, l2, color);
    Pt(g, i + 10, l2, color);
    Pt(g, i + 13, l2, color);
    Pt(g, i + 15, l2, color);
    Pt(g, i + 17, l2, color);
    Pt(g, i + 21, l2, color);
    l2 = j + 5;
    for(int l1 = i + 1; l1 <= i + 3; l1++) Pt(g, l1, l2, color);
    for(int i2 = i + 19; i2 <= i + 21; i2++) Pt(g, i2, l2, color);
    for(int j2 = i + 6; j2 <= i + 8; j2++) Pt(g, j2, l2, color);
    for(int k2 = i + 15; k2 <= i + 17; k2++) Pt(g, k2, l2, color);
    Pt(g, i + 10, l2, color);
    Pt(g, i + 13, l2, color);
  }

  public void Aff(Graphics g, int i, int j, Color color)
  { switch(i)
    { case 1: Un(g, 10 + j, 191, color); break;
      case 2: Deux(g, 10 + j, 191, color); break;
      case 3: Trois(g, 10 + j, 191, color); break;
      case 4: Quatre(g, 10 + j, 191, color); break;
      case 5: Cinq(g, 10 + j, 191, color); break;
      case 6: Six(g, 10 + j, 191, color); break;
      case 7: Sept(g, 10 + j, 191, color); break;
      case 8: Huit(g, 10 + j, 191, color); break;
      case 9: Neuf(g, 10 + j, 191, color); break;
      case 0: Zero(g, 10 + j, 191, color); break;
    }
  }

  public void AffNb(Graphics g, int i, int j, Color color)
  { if(i < 10) Aff(g, i, j, color);
    else
    { if(i < 100)
      { int i1 = i % 10;
        int k = i / 10;
        Aff(g, k, j, color);
        Aff(g, i1, 6 + j, color);
      }
      else
      { if(i < 1000)
        { int l = i / 100;
          int j1 = (i % 100) / 10;
          int k1 = i % 100 % 10;
          Aff(g, l, j, color);
          Aff(g, j1, 6 + j, color);
          Aff(g, k1, 12 + j, color);
        }
        else
        { Aff(g, 0, j, color);
          Aff(g, 0, 6 + j, color);
        }
      }
    }
  }

  public void AffVie(Graphics g, int i)
  { for(int j = 0; j <= i - 2 && j < 5; j++)
    { Pallet(g, 280 - 50 * j, 192, Color.black, new Color(201, 201, 201), new Color(137, 137, 137));
    }
  }

  public Color NivColor(int i)
  { if(game.world.NivAtt >= i) return Color.green;
    else return Color.red;
  }

  public void DesPortes(Graphics g, int i)
  { game.world.cont++;
    if(game.world.cont == 1000) game.world.cont = 0;
    if(i == 10)
    { Porte(g, 97, 139);
      Un(g, 103, 132, NivColor(1));
      Porte(g, 129, 99);
      Trois(g, 134, 92, NivColor(3));
      Porte(g, 193, 139);
      Deux(g, 198, 132, NivColor(2));
      Porte(g, 193, 59);
      TBonus(g, 196, 52, Color.green);
      PanneauExit(g, 4, 140);
      if(game.world.NivAtt > 3) FlecheD(g, 300, 83, Color.white);
      if(game.world.TheEnd) FlecheG(g, 13, 123, Color.white);
    }
    else if(i == 11)
    { Porte(g, 193, 59);
      Six(g, 198, 52, NivColor(6));
      Porte(g, 65, 59);
      Quatre(g, 70, 52, NivColor(4));
      Porte(g, 129, 59);
      Cinq(g, 134, 52, NivColor(5));
      PanneauExit(g, 4, 140);
      FlecheG(g, 13, 83, Color.white);
      if(game.world.NivAtt > 6) FlecheD(g, 300, 83, Color.white);
    }
    else if(i == 12)
    { FlecheG(g, 13, 83, Color.white);
      PanneauExit(g, 4, 140);
      FlecheD(g, 300, 163, Color.white);
    }
    else if(i == 13)
    { Porte(g, 65, 59);
      Huit(g, 70, 52, NivColor(8));
      Porte(g, 289, 59);
      Sept(g, 294, 52, Color.green);
      Porte(g, 161, 139);
      TBonus(g, 164, 132, Color.green);
      FlecheG(g, 13, 163, Color.white);
      ExitG(g, 45, 167);
      if(game.world.TheEnd)
      { PanneauEnd(g, 4, 30);
        FlecheD(g, 300, 123, Color.white);
      }
    }
  }

  public void Trace(Graphics g, int i)
  { if(game.world.Niv == 9)
    { for(int i1 = 0; i1 <= 2; i1++)
      { int j1 = 0;
        for(int k = 0; k <= 9; k++)
        { if(game.world.Ecran[9].t[k][i1] == 1)
          {      if(j1 % 5 == 0)       BrikB(g, 32 * k + 1, 10 * i1 + 10, Color.red);
            else if((j1 - 1) % 5 == 0) BrikO(g, 32 * k + 1, 10 * i1 + 10, Color.red);
            else if((j1 - 2) % 5 == 0) BrikN(g, 32 * k + 1, 10 * i1 + 10, Color.red);
            else if((j1 - 3) % 5 == 0) BrikU(g, 32 * k + 1, 10 * i1 + 10, Color.red);
            else if((j1 - 4) % 5 == 0) BrikS(g, 32 * k + 1, 10 * i1 + 10, Color.red);
            j1++;
          }
        }
      }
    }
    else
    { for(int j = 0; j <= 9; j++)
      { for(int l = 0; l <= 16; l++)
        {      if(game.world.Ecran[i].t[j][l] == 1) Brik(g, 32 * j + 1, 10 * l + 10, Sbc1, Sbc2, Sbc3, Sbc4, Sbc5);
          else if(game.world.Ecran[i].t[j][l] == 2) Brik(g, 32 * j + 1, 10 * l + 10, Ibc1, Ibc2, Ibc3, Ibc4, Ibc5);
          else if(game.world.Ecran[i].t[j][l] == 3) BrikE(g, 32 * j + 1, 10 * l + 10, Ebc1, Ebc2, Ebc3, Ebc4, Ebc5);
          else if(game.world.Ecran[i].t[j][l] == 4) BrikE(g, 32 * j + 1, 10 * l + 10, Ebc, Ebc, Ebc, Ebc, Ebc);
        }
      }
    }
  }

  public void Trace1(Graphics g, int i)
  { for(int j = 0; j <= 9; j++)
    { for(int k = 0; k <= 16; k++)
      {      if(game.world.Ecran[i].t[j][k] == 1) Brik(g, 32 * j + 1, 10 * k, Sbc1, Sbc2, Sbc3, Sbc4, Sbc5);
        else if(game.world.Ecran[i].t[j][k] == 2) Brik(g, 32 * j + 1, 10 * k, Ibc1, Ibc2, Ibc3, Ibc4, Ibc5);
        else if(game.world.Ecran[i].t[j][k] == 3) BrikE(g, 32 * j + 1, 10 * k, Ebc1, Ebc2, Ebc3, Ebc4, Ebc5);
      }
    }
  }

  public void Ecrans(Graphics g)
  { Clear(g, Bkc);
    Trace1(g, game.world.Niv);
    AffNb(g, game.world.score, 10, Color.gray);
    AffVie(g, game.world.Vie);
    DesPortes(g, game.world.Niv);
    Balle(g, game.world.xb, game.world.yb, Color.black, Color.gray, Color.white);
  }

  public void Niveau(Graphics g)
  { Clear(g, Bkc);
    Trace(g, game.world.Niv);
    AffNb(g, game.world.score, 10, Color.gray);
    AffVie(g, game.world.Vie);
    if
    ( game.world.CShoot.presence &&
      ( game.world.Niv != 8 &&
        game.world.Niv != 14 ||
        game.world.Niv == 8 &&
        game.world.OkCaps8[1] ||
        game.world.Niv == 14 &&
        game.world.OkCaps14[1]
      )
    )
    Capsule(g, game.world.CShoot.x, game.world.CShoot.y, Color.black, game.world.CShoot.col);
    if
    ( game.world.CScotch.presence &&
      ( game.world.Niv != 8 &&
        game.world.Niv != 14 ||
        game.world.Niv == 8 &&
        game.world.OkCaps8[2] ||
        game.world.Niv == 14 &&
        game.world.OkCaps14[2]
      )
    )
    Capsule(g, game.world.CScotch.x, game.world.CScotch.y, Color.black, game.world.CScotch.col);
    if
    ( game.world.CVie.presence &&
      ( game.world.Niv != 8 &&
        game.world.Niv != 14 ||
        game.world.Niv == 8 &&
        game.world.OkCaps8[3] ||
        game.world.Niv == 14 &&
        game.world.OkCaps14[3]
      )
    )
    Capsule(g, game.world.CVie.x, game.world.CVie.y, Color.black, game.world.CVie.col);
    if(game.world.Niv == 8)
    { DetecteurD(g, 0, 30);
      DetecteurG(g, 319, 30);
      Rayon(g, 34);
    }
    if(game.world.Niv == 14)
    { DetecteurD(g, 0, 100);
      DetecteurG(g, 319, 100);
      Rayon(g, 104);
    }
    for(int i = 1; i <= 20; i++)
    { if(game.world.FireTab[i].Sh) Tir(g, game.world.FireTab[i].x, game.world.FireTab[i].y, Color.red);
    }
    Pallet(g, game.world.xp, game.world.yp, Color.black, new Color(201, 201, 201), new Color(137, 137, 137));
    if(game.world.BalleCondition()) Balle(g, game.world.xb, game.world.yb, Color.black, Color.gray, Color.white);
  }

}
